# $Id: TExit.tcl,v 1.3 2001/11/25 20:30:33 issever Exp $

### class definition ----------------------------------------
class TExitManager {
    public  common CDirs "nw nc ne cw ce sw sc se uo ux do dx"
    public  common CGrid 
    public  common CDirConP
    public  common CImage
    private variable CIM

    constructor {aGrid aIM} {}
}
class TExitList {
    variable CExitList

    constructor {args} {}
    destructor {}
    method add {aExit}
    method rem {aPos} 
    method exists {aPos}
    method getPoss {}
    method getExit {aPos}
    method getPosOfExitWithCommand {aCom} {
	set retpos ""
	foreach pos [TExitList::getPoss] {
	    set ex [TExitList::getExit $pos]
	    if {![string compare [$ex getCommand] $aCom]} {
		set retpos $pos
		break
	    }
	}
	return $retpos
    }
    method = {source} 
    method streamout {} {
	set il [list]
	foreach pos [TExitList::getPoss] {
	    lappend il [[getExit $pos] streamout]
	}
	return $il
    }
    method streamin {arg} {
	foreach exs $arg {
	    set dummy [TExit ::\#auto]
	    $dummy streamin $exs
	    TExitList::add $dummy
	    ::delete object $dummy
	}
    }
}
class TExitListUif {
    inherit itk::Widget

    variable CParent
    variable CMapM
    variable CSelector
    variable CEntryX

    private variable CBGColor     "\#daceaf"
    private variable CBGDarkColor "\#a97"

    method getMapM {} { return $CMapM }

    itk_option define -foreground foreground Foreground black {
	#$itk_component(selexit) configure -foreground $itk_option(-foreground)
    }
    constructor {aParent aMapM aIMM args} {
	TExitList::constructor
    } {
	# parent is a roomuif	
	set wid $itk_interior.f
	set CMapM $aMapM
	set CIMM $aIMM
	regsub -- {^::} $aParent {} CParent	
	set CEntryX [$aParent getEntryX]

	itk_component add mainframe {frame $wid -relief ridge -bd 2 } {keep -background}
	pack $itk_component(mainframe) -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0
	###################################################################################
	# buttons
	foreach ns {n c s} {
	    itk_component   add bf$ns {frame $itk_component(mainframe).$ns -relief flat -bd 0} {usual}

	    pack $itk_component(bf$ns) -fill both -expand true -side top

	    foreach we {w c e} {
		switch $ns$we {
		    cc {
			itk_component   add ccf {frame $itk_component(bf$ns).$we -relief flat -bd 0} {usual}
			pack $itk_component(ccf) -fill both -expand true -side left

			foreach ud {u d} {
			    itk_component   add udf$ud {frame $itk_component(ccf).$ud -relief flat -bd 0} {usual}
			    pack $itk_component(udf$ud) -fill both -expand true -side top

			    foreach ox {o x} {
				itk_component   add $ud$ox {
				    button $itk_component(udf$ud).$ox -width 4 -text "" -font small \
					-command "[code $this useExit $ud$ox]"
				} { usual ; ignore -font ; keep -foreground }
				pack $itk_component($ud$ox) -fill both -expand true -side left 
				bind $itk_component($ud$ox) <<ZIFExtended>>       "[code $this launchUIF $ud$ox]"
				bind $itk_component($ud$ox) <<ZIFShortcut>>       "[code $this shortCutAction $ud$ox]"

				rem $ud$ox
			    }
			}
		    }
		    default {
			itk_component   add $ns$we {
			    button $itk_component(bf$ns).$we -width 5 -text "" -font small \
				-command "[code $this useExit $ns$we]"
			} { usual ; ignore -font ; keep -foreground }
			pack $itk_component($ns$we) -fill x -expand 1 -side left
			bind $itk_component($ns$we) <<ZIFExtended>>        "[code $this launchUIF $ns$we]"
			bind $itk_component($ns$we) <<ZIFShortcut>>        "[code $this shortCutAction $ns$we]"

			rem $ns$we
		    }
		}
	    }
	}
	
	set CSelector $itk_interior.selector
	itk_component add selec {
	    TExitSelector $CSelector $this $CIMM \
		-master [winfo toplevel $itk_interior] \
		-tops [winfo toplevel $itk_interior] 
	} {
	    keep -foreground
	    keep -background
	}

	eval itk_initialize $args
    }

    method clearUif {} {
	foreach pos $TExitManager::CDirs {
	    rem $pos
	}
    }
    method setUif {aRoom} {
	clearUif
	$CParent TExitList::= $aRoom
	foreach expos [$aRoom TExitList::getPoss] {
	    $itk_component($expos) configure -text [[$aRoom TExitList::getExit $expos] getCommand]
	}
    }

    method launchUIF {aPos} {
	if {![$CParent mayEdit]} {
	    TInformer $itk_interior.mess \
		-vanishafter 2 \
		-information "No map available!"
	    return
	}
	$CSelector setActPos $aPos $CParent
	$CSelector activate 
    }
    method add {ex} {
	$CParent changed
	$CParent createTheRoom
	$CParent TExitList::add $ex
	$itk_component([$ex getDir]) configure -text [$ex getCommand]
    }
    method setExitCommand {aPos aCom} {
	[getExit $aPos] setCommand $aCom
	$itk_component($aPos) configure -text $aCom
    }
    method rem {aPos} {
	$CParent changed
	$CParent TExitList::rem $aPos
	$itk_component($aPos) configure -text ""
    }
    method exists {aPos} {
	return [$CParent TExitList::exists $aPos]
    }
    method getExit {aPos} {
	return [$CParent TExitList::getExit $aPos]
    }
    method useExit {aPos} {
	if {![$CParent hasMap]} {
	    TInformer $itk_interior.mess \
		-vanishafter 2 \
		-information "No map available!"
	    return
	}
	#Pass it to the mapmanager
	$CMapM useExit $aPos
    }
    method shortCutAction {aPos} {
	if {![$CParent mayEdit]} {
	    TInformer $itk_interior.mess \
		-vanishafter 2 \
		-information "No map available!"
	    return
	}
	if {[exists $aPos]} {
	    switch -regexp -- $aPos {
		n[we] {
		    if {[string match "north*" [[getExit $aPos] getCommand]]} {
			setExitCommand $aPos "up"
		    } else {
			rem $aPos
		    }
		}
		s[we] {
		    if {[string match "south*" [[getExit $aPos] getCommand]]} {
			setExitCommand $aPos "down"
		    } else {
			rem $aPos
		    }
		}
		default {
		    rem $aPos
		}
	    }
	} else {
	    # create an exit
	    set cc [TCoordinate ::\#auto [$CMapM getActCoord]]
	    $cc move $aPos
	    set cd [TCoordinate ::\#auto $cc]	
	    set actmap [$CMapM getActMap]
	    set mapn   [$actmap name]
	    set mapl   [$actmap level]

	    switch -regexp -- $aPos {
		d[ox] {
		    incr mapl -1
		}		
		u[ox] {
		    incr mapl +1
		}		
		default {
		    set mapn ""
		    set mapl ""
		}
	    }

	    set ex [TExit ::\#auto $aPos $mapn $mapl $cc $cd [TExit::qECom $aPos] 0 "" "" 2 "black"]
	    
	    add $ex
	    ::delete object $ex $cc $cd
	}
    }
    method = {source} {
	foreach pos [$source TExitList::getPoss] {
	    add [$source getExit $pos]
	}
    }


}
class TExit {
    variable CDir          ""  ;#- the direction whre the exit is located in the room
    variable CExitCommand  ""  ;#- The command that should be sent to the mud, when this exit is entered

    variable CDoor         ""  ;#- Indicator for doors: [door|no door]
    variable CDoorOpen     ""
    variable CDoorClose    ""

    variable CMap          ""  ;#- The Map this exit leads to.
    variable CMapLevel     ""  ;#- The Map this exit leads to.
    variable CConnectTo    ""  ;#- the coordinate the exits leads to
    variable CDrawTo       ""  ;#- the coordinate the exits is drawn to _on_the_same_map_.

    variable CConThickness    "2"
    variable CConColor        "black"

    public  common CDirs "nw nc ne cw ce sw sc se uo ux do dx"
    proc     dirs {return $CDirs}

    proc     qECom {aPos} {
	switch -regexp -- $aPos {
	    nw { return northwest }
	    nc { return north }
	    ne { return northeast }
	    cw { return west }
	    ce { return east }
	    sw { return southwest }
	    sc { return south }
	    se { return southeast }
	    do { return down }
	    dx { return down }
	    uo { return up }
	    ux { return up }
	    default  { return "" }
	}
    }
    method streamout {} {
	return [list $CDir $CExitCommand $CDoor $CDoorOpen $CDoorClose $CMap $CMapLevel [$CConnectTo streamout] [$CDrawTo streamout] $CConThickness $CConColor]
    }
    method streamin {arg} {
	set CDir                 [lindex $arg 0]
	set CExitCommand         [lindex $arg 1]
	set CDoor                [lindex $arg 2]
	set CDoorOpen            [lindex $arg 3]
	set CDoorClose           [lindex $arg 4]
	set CMap                 [lindex $arg 5]
	set CMapLevel            [lindex $arg 6]
	$CConnectTo streamin     [lindex $arg 7]
	$CDrawTo    streamin     [lindex $arg 8]
	set CConThickness        [lindex $arg 9]
	set CConColor            [lindex $arg 10]
    }

    constructor {args} {}
    destructor {}
    method = {source} 
    method getDir       {} {return $CDir}
    method getMap       {} {return $CMap}
    method getMapLevel  {} {return $CMapLevel}
    method getCommand   {} {return $CExitCommand}
    method getDoor      {} {return $CDoor}
    method hasDoor      {} {return $CDoor}
    method getDoorOpen  {} {return $CDoorOpen}
    method getDoorClose {} {return $CDoorClose}
    method getConnectTo {} {return $CConnectTo}
    method getDrawTo    {} {return $CDrawTo}
    method getConThickness {} {return $CConThickness}
    method getConColor     {} {return $CConColor}

    method setCommand {aCom} { set CExitCommand $aCom}

    method isRelative {} {
	if {[string compare "" $CMap]} {
	    return 0
	}
	return 1
    }
    method moveby {aX aY} {
	$CConnectTo moveby $aX $aY
	$CDrawTo moveby $aX $aY
    }
    
}
############################################################################################################
############################################################################################################
############################################################################################################
############################################################################################################
############################################################################################################
###############################################################
class TExitSelector {
    inherit iwidgets::Shell

    variable CParent
    variable CActPos
    variable CIMM

    method setActPos {aPos aActCoord} {
	global TV
	set CActPos $aPos
	configure -title "Configure Exit: $CActPos"
	configure -modality application

	if {[$CParent exists $aPos]} {
	    set ex [$CParent getExit $aPos]	    
	    set TV($this,command)    [$ex getCommand]
	    set TV($this,map)        [$ex getMap]
	    set TV($this,mapl)       [$ex getMapLevel]
	    set TV($this,door)       [$ex getDoor]
	    set TV($this,doorOpen)   [$ex getDoorOpen]
	    set TV($this,doorClose)  [$ex getDoorClose]
	    $itk_component(conxy)  = [$ex getConnectTo]
	    $itk_component(drawxy) = [$ex getDrawTo]
	    set TV($this,color)      [$ex getConColor]
	    $itk_component(thick) delete 0 end
	    $itk_component(thick) insert 0 [$ex getConThickness]
	} else {
	    set TV($this,command)    ""
	    set TV($this,map)        ""
	    set TV($this,mapl)       ""
	    set TV($this,door)       0
	    set TV($this,doorOpen)   ""
	    set TV($this,doorClose)  ""
	    set TV($this,color)      "black"
	    $itk_component(conxy)    = $aActCoord
	    $itk_component(conxy)    move $aPos
	    $itk_component(drawxy)   = $itk_component(conxy)  
	    $itk_component(thick) delete 0 end
	    $itk_component(thick) insert 0 2
	}
    }
    method doorWasToggled {} {
	global TV
	if {$TV($this,door)} {
	    set TV($this,doorOpen)  "open door"
	    set TV($this,doorClose) "close door"
	}
    }
    constructor {aParent aIMM args} {
	# parent is an ExitListUif
	global TV
	set CIMM $aIMM
	set CActPos ""
	set CMapped 0

	regsub -- {^::} $aParent {} CParent

	set wid [$this childsite]
	$wid configure -relief ridge -bd 0

	#########################################################################
	# create buttons
	itk_component add   butframe {frame $wid.butframe -relief ridge -bd 2 } {keep -background}
	pack $itk_component(butframe) -side bottom -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0
	itk_component add   ok {
	    button $itk_component(butframe).ok -width 10 -text "OK" -command "[code $this OK]"
	} {keep -background;keep -foreground}
	itk_component add   rem {
	    button $itk_component(butframe).rem -width 10 -text "remove" -command "[code $this remove]"
	} {keep -background;keep -foreground}
	itk_component add   canc {
	    button $itk_component(butframe).canc -width 10 -text "cancel" -command "[code $this canc]"
	} {keep -background;keep -foreground}
	pack $itk_component(ok) $itk_component(rem) $itk_component(canc) \
	    -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left


	###########################################################################
	# create the rest
	itk_component add rframe {frame $wid.r -relief ridge -bd 2 } {keep -background}
	pack $itk_component(rframe) -fill both -expand 1 -ipadx 0 -ipady 0 -padx 0 -pady 0 -side top

	# command
	itk_component   add comf { frame $itk_component(rframe).comf -relief ridge -borderwidth 2 } {usual}
	pack $itk_component(comf) -fill both -expand 1 -side top -anchor nw
	itk_component   add command {iwidgets::entryfield $itk_component(comf).com \
					 -labeltext "command: " \
					 -width 4 -textfont def \
					 -labelmargin 0 -textvariable TV($this,command)
	} {keep -background;keep -foreground}
	pack $itk_component(command) -fill both -expand 1 -side top -anchor nw
	#map
	itk_component   add mapf { frame $itk_component(rframe).mapf -relief ridge -borderwidth 2 } {usual}
	pack $itk_component(mapf) -fill both -expand 1 -side top -anchor nw
	itk_component   add map {iwidgets::entryfield $itk_component(mapf).map \
				     -labeltext "map: " \
				     -width 12 -textfont def -labelfont def \
				     -labelmargin 0 -textvariable TV($this,map)
	} {keep -background;keep -foreground}
	itk_component   add mapl {iwidgets::entryfield $itk_component(mapf).mapl \
				      -width 3 -textfont def -labelfont def \
				      -validate integer \
				      -labelmargin 0 -textvariable TV($this,mapl)
	} {keep -background;keep -foreground}
	pack $itk_component(map) $itk_component(mapl) -fill both -expand 1 -side left -anchor nw
	iwidgets::Labeledwidget::alignlabels $itk_component(command) $itk_component(map)

	# door
	itk_component   add doorf { frame $itk_component(rframe).doorf -relief ridge -borderwidth 2 } {usual}
	pack $itk_component(doorf) -fill x -expand 1 -side top -anchor nw
	itk_component   add doorcheck {
	    checkbutton $itk_component(doorf).door -text door -selectcolor red \
		-relief flat -justify left -anchor nw -font def \
		-variable TV($this,door) -command "[code $this doorWasToggled]"
	} {usual; ignore -font}
	itk_component   add dooropen {iwidgets::entryfield $itk_component(doorf).open \
					  -labeltext "open:" -width 3 -labelfont def \
					  -textfont def -labelmargin 0 \
					  -textvariable TV($this,doorOpen)
	} {keep -background;keep -foreground}
	itk_component   add doorclose {iwidgets::entryfield $itk_component(doorf).close \
					   -labeltext "close:" -width 3 -labelfont def \
					   -textfont def -labelmargin 0 \
					   -textvariable TV($this,doorClose)
	} {keep -background;keep -foreground}
	iwidgets::Labeledwidget::alignlabels $itk_component(dooropen) $itk_component(doorclose)

	pack $itk_component(doorcheck) $itk_component(dooropen) $itk_component(doorclose) \
	    -fill x -expand 1 -side top -anchor nw -padx 0 -pady 0 -ipadx 0 -ipady 0

	######## con/draw
	itk_component   add cond { 
	    frame $itk_component(rframe).cond -relief ridge -borderwidth 2 
	} {usual}
	pack $itk_component(cond) -fill x -expand 1 -side top -anchor nw
	###### con
	itk_component   add con   { frame $itk_component(cond).con -relief flat -borderwidth 0 } {usual}
	pack $itk_component(con)   -fill both -expand 1 -side top -anchor nw
	itk_component   add conxy { 
	    TCoordinateUif $itk_component(con).xy -orient h -xtext   "Connect x: " 
	} {
	    keep -foreground
	    keep -background
	}
	itk_component   add conc  { 
	    button $itk_component(con).conc -image [$CIMM getImage system buttons click] \
		-command [code $this clickCon]		
	} {keep -background;keep -foreground}
	itk_component   add conr  { 
	    button $itk_component(con).conr -image [$CIMM getImage system buttons cut] \
		-command [code $this remCon]
	} {keep -background;keep -foreground}
	pack $itk_component(conxy) $itk_component(conc) $itk_component(conr) \
	    -fill both -expand 1 -side left -anchor nw
	###### draw
	itk_component   add draw   { frame $itk_component(cond).draw -relief flat -borderwidth 0 } {usual}
	pack $itk_component(draw)  -fill both -expand 1 -side top -anchor nw
	itk_component   add drawxy { 
	    TCoordinateUif $itk_component(draw).xy -orient h -xtext "Draw    x: " 
	} {
	    keep -background
	    keep -foreground
	}
	itk_component   add drawc  { 
	    button $itk_component(draw).drawc -image [$CIMM getImage system buttons click] \
		-command [code $this clickDraw]		
	} {keep -background;keep -foreground}
	itk_component   add drawr  { 
	    button $itk_component(draw).drawr -image [$CIMM getImage system buttons cut] \
		-command [code $this remDraw]
	} {keep -background;keep -foreground}
	pack $itk_component(drawxy) $itk_component(drawc) $itk_component(drawr) \
	    -fill both -expand 1 -side left -anchor nw
	###### color/thickness
	itk_component   add colort   { frame $itk_component(cond).colort -relief flat -borderwidth 0 } {usual}
	pack $itk_component(colort)  -fill both -expand 1 -side top -anchor nw

	itk_component   add thick { 
	    iwidgets::spinint $itk_component(colort).thick \
		-labeltext "Thickness: " -range {0 64} -width 3 -arroworient horizontal
	} {keep -background;keep -foreground}

	itk_component   add color { 
	    iwidgets::combobox $itk_component(colort).color \
		-editable 0 -width 10 -textvariable TV($this,color) -labeltext "Color: "
	} {keep -background;keep -foreground}
	$itk_component(color) insert list end \
	   black red green blue "bg def" "bg dark" white yellow magenta cyan 
 	pack $itk_component(thick) $itk_component(color) -fill both -expand 1 -side left -anchor nw


	eval itk_initialize $args
    }
    method remCon  {} { 
	$itk_component(conxy) setNull 
	remDraw
    }
    method remDraw {} { 
	$itk_component(drawxy) setNull 
    }
    method clickCon {} {
	$this deactivate
	[$CParent getMapM] clickCon $this
    }
    method clickConClick {x y mapname maplevel} {	
	global TV
	if {$maplevel == 0} { set maplevel "" }
	if {![string compare "" $mapname]} { set maplevel "" }
	set TV($this,map)        $mapname
	set TV($this,mapl)       $maplevel	
	$itk_component(conxy) setXY $x $y
	if {![string compare "" $mapname]} {
	    $itk_component(drawxy) setXY $x $y
	}
	$this activate
    }
    method clickDraw {} {
	$this deactivate
	[$CParent getMapM] clickDraw $this
    }
    method clickDrawClick {x y} {
	$itk_component(drawxy) setXY $x $y
	$this activate
    }
    method canc {} { 
	$this deactivate 
    }
    method remove {} {
	$CParent rem $CActPos
	canc
    }
    method OK {} {
	global TV
	if {![string compare $TV($this,command) ""]} {
	    TInformer $itk_interior.mess \
		-information "You have to give a 'command'!\nOtherwise remove the exit."
	    return
	}

	set ex [TExit ::\#auto $CActPos \
		    $TV($this,map) $TV($this,mapl) \
		    $itk_component(conxy) $itk_component(drawxy) \
		    $TV($this,command) \
		    $TV($this,door) $TV($this,doorOpen) $TV($this,doorClose) \
		    [$itk_component(thick) get] $TV($this,color) ]
	$CParent add $ex
	::delete object $ex

	canc
    }
}
###############################################################################################################


############################################################################################################
body TExitManager::constructor {aGrid aIM} {
    set CGrid $aGrid
    set CIM   $aIM

    set CDirConP(nw,x) [expr -0.5*$CGrid]
    set CDirConP(nc,x) [expr  0]
    set CDirConP(ne,x) [expr  0.5*$CGrid]
    set CDirConP(nw,y) [expr -0.5*$CGrid]
    set CDirConP(nc,y) [expr -0.5*$CGrid]
    set CDirConP(ne,y) [expr -0.5*$CGrid]
    set CDirConP(cw,x) [expr -0.5*$CGrid]
    set CDirConP(cc,x) [expr  0]
    set CDirConP(ce,x) [expr  0.5*$CGrid]
    set CDirConP(cw,y) [expr  0]
    set CDirConP(cc,y) [expr  0]
    set CDirConP(ce,y) [expr  0]
    set CDirConP(sw,x) [expr -0.5*$CGrid]
    set CDirConP(sc,x) [expr  0]
    set CDirConP(se,x) [expr  0.5*$CGrid]
    set CDirConP(sw,y) [expr  0.5*$CGrid]
    set CDirConP(sc,y) [expr  0.5*$CGrid]
    set CDirConP(se,y) [expr  0.5*$CGrid]
    
    set CDirConP(uo,x) -8
    set CDirConP(uo,y) -8
    set CDirConP(do,x) -8
    set CDirConP(do,y)  8
    set CDirConP(ux,x)  8
    set CDirConP(ux,y) -8
    set CDirConP(dx,x)  8
    set CDirConP(dx,y)  8

    foreach pos {uo do ux dx} {
	set CImage($pos) [$CIM getImage system exits $pos]
    }
    
}


### ----------------------------------------------------------
body TExit::constructor {args} {
    switch [llength $args] {
	0 {		
	    set CConnectTo           [TCoordinate ::\#auto ]
	    set CDrawTo              [TCoordinate ::\#auto    ]
	}
	1 {
	    set CConnectTo           [TCoordinate ::\#auto ]
	    set CDrawTo              [TCoordinate ::\#auto    ]
	    TExit::= $args
	}
	11 {
	    set CDir                 [lindex $args 0]
	    set CMap                 [lindex $args 1]
	    set CMapLevel            [lindex $args 2]
	    set CConnectTo           [TCoordinate ::\#auto [lindex $args 3]]
	    set CDrawTo              [TCoordinate ::\#auto    [lindex $args 4]]
	    set CExitCommand         [lindex $args 5]
	    set CDoor                [lindex $args 6]
	    set CDoorOpen            [lindex $args 7]
	    set CDoorClose           [lindex $args 8]
	    set CConThickness        [lindex $args 9]
	    set CConColor            [lindex $args 10]
	}
	default {
	    error "Wrong numer of arguments to constructor!"
	}
	
    }	
} 
body TExit::destructor {} {
    ::delete object $CConnectTo
    ::delete object $CDrawTo
}

body TExit::= {source} {
    set CDir          [$source getDir]
    set CMap          [$source getMap]
    set CMapLevel     [$source getMapLevel]
    set CExitCommand  [$source getCommand]
    set CDoor         [$source getDoor]
    set CDoorOpen     [$source getDoorOpen]
    set CDoorClose    [$source getDoorClose]
    ::delete object $CConnectTo $CDrawTo
    set CConnectTo           [TCoordinate ::\#auto [$source getConnectTo]]
    set CDrawTo              [TCoordinate ::\#auto    [$source getDrawTo]]
    set CConColor       [$source getConColor]
    set CConThickness   [$source getConThickness]
}
### ----------------------------------------------------------

body TExitList::constructor {args} {
    switch [llength $args] {
 	0 {		
 	}
 	1 {
 	    TExitList::= $args
 	}
 	default {
 	    error "Wrong numer of arguments to constructor!"
 	}
	
    }	
}

body TExitList::destructor {} {
    foreach pos [TExitList::getPoss] {
 	::delete object [TExitList::getExit $pos]
    }	
}

body TExitList::add {aExit} {
    set dir [$aExit getDir]
    TExitList::rem $dir
    set CExitList($dir) [TExit ::TExitListExit\#auto $aExit]
}
body TExitList::rem {aPos} {
    if {[info exists CExitList($aPos)]} {
 	::delete object $CExitList($aPos)
 	unset CExitList($aPos)
    }	
}
body TExitList::exists {aPos} {
    return [info exists CExitList($aPos)]
}
body TExitList::getPoss {} {
    return [array names CExitList]
}
body TExitList::getExit {aPos} {
    return $CExitList($aPos)
}

body TExitList::= {source} {
    foreach pos [$source TExitList::getPoss] {
 	TExitList::add [$source getExit $pos]
    }
}











# ##############################################################################
# ### LOG MESSAGES
# ### As suggested by the CVS-manual this region is put to the end of the file.
# ##############################################################################
#
# $Log: TExit.tcl,v $
# Revision 1.3  2001/11/25 20:30:33  issever
# Removed the -foreground bug.
# This was a quite widespread bug and I hope I caught
# every appereance. If I've missed one, please notify
# us again.
#
# Revision 1.2  2001/08/19 12:25:42  issever
# Added the cvs keywords Id at start of the file
# and Log at the end of the file
#
#
